PROGRAM Int_Spline

USE Spline

IMPLICIT NONE

INTEGER         :: i
TYPE (Spline1D) :: TestSpline
CHARACTER(LEN=100) :: PointString
DOUBLE PRECISION :: Point
INTEGER, PARAMETER :: MaxPoints = 1000

CALL GETARG( 1, PointString )
READ( PointString, * ) Point

! Read the data
OPEN( 100, FILE="FILE.1d", STATUS="OLD" )

TestSpline%NX = MaxPoints

CALL Allocate_Spline1D( TestSpline, TestSpline%NX )

i = 0

DO
  i = i + 1
  READ( 100, *, END=1000, ERR=1000 ) TestSpline%X(i), TestSpline%F(i)
END DO

1000 CONTINUE
TestSpline%NX = i - 1

CALL Compute_Spline1D( TestSpline, 0, 0.0, 0, 0.0 )

CLOSE( 100 )

PRINT *, "These abscissae were used:"
PRINT *, TestSpline%X(1:TestSpline%NX)
PRINT *

PRINT *, "The spline evaluated at x=", Point, " equals"
PRINT *, Evaluate_Spline1D( TestSpline, Point )
PRINT *, Evaluate_Spline1D_Derivative( TestSpline, Point )

END PROGRAM

